"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSelectedPadding = exports.normalizeValues = exports.isEnabled = void 0;

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.function.name.js");

require("core-js/modules/es.array.find.js");

var _constants = require("./constants");

/* eslint-disable import/prefer-default-export */
var isEnabled = function isEnabled(values) {
  return values.length > 0;
};

exports.isEnabled = isEnabled;

var normalizeValues = function normalizeValues(parameters) {
  var _parameters$values;

  if (!parameters || parameters.disable || !((_parameters$values = parameters.values) != null && _parameters$values.length)) {
    return [];
  }

  return parameters.values.map(function (item) {
    var name = item.name,
        value = item.value;
    var isDefault = parameters.default === name;
    return {
      name: name,
      value: value,
      default: isDefault
    };
  });
};

exports.normalizeValues = normalizeValues;

var getSelectedPadding = function getSelectedPadding(values, currentValue) {
  var _values$find$value, _values$find;

  if (currentValue === _constants.DEFAULT_PADDING) {
    return currentValue;
  }

  if (values.find(function (_ref) {
    var value = _ref.value;
    return value === currentValue;
  })) {
    return currentValue;
  }

  return (_values$find$value = (_values$find = values.find(function (option) {
    return option.default;
  })) == null ? void 0 : _values$find.value) != null ? _values$find$value : _constants.DEFAULT_PADDING;
};

exports.getSelectedPadding = getSelectedPadding;