"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.withPaddings = void 0;

var _addons = require("@storybook/addons");

var _constants = require("./constants");

var _helpers = require("./helpers");

var setStyle = function setStyle() {
  var padding = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _constants.DEFAULT_PADDING;
  document.body.style.margin = '0';
  document.body.style.padding = padding;
  document.body.style.transition = 'padding .3s';
};

var withPaddings = function withPaddings(getStory, context) {
  var _globals$PARAM_KEY;

  var globals = context.globals,
      parameters = context.parameters;
  var globalsSelectedPadding = (_globals$PARAM_KEY = globals[_constants.PARAM_KEY]) == null ? void 0 : _globals$PARAM_KEY.value;
  var paddingsConfig = parameters[_constants.PARAM_KEY]; // eslint-disable-next-line react-hooks/rules-of-hooks

  (0, _addons.useMemo)(function () {
    var selectedPadding = (0, _helpers.getSelectedPadding)((0, _helpers.normalizeValues)(paddingsConfig), globalsSelectedPadding);
    setStyle(selectedPadding);
  }, [paddingsConfig, globalsSelectedPadding]);
  return getStory(context);
};

exports.withPaddings = withPaddings;
var _default = withPaddings;
exports.default = _default;