import { useMemo } from '@storybook/addons';
import { DEFAULT_PADDING, PARAM_KEY } from './constants';
import { normalizeValues, getSelectedPadding } from './helpers';

var setStyle = function setStyle() {
  var padding = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DEFAULT_PADDING;
  document.body.style.margin = '0';
  document.body.style.padding = padding;
  document.body.style.transition = 'padding .3s';
};

export var withPaddings = function withPaddings(getStory, context) {
  var _globals$PARAM_KEY;

  var globals = context.globals,
      parameters = context.parameters;
  var globalsSelectedPadding = (_globals$PARAM_KEY = globals[PARAM_KEY]) == null ? void 0 : _globals$PARAM_KEY.value;
  var paddingsConfig = parameters[PARAM_KEY]; // eslint-disable-next-line react-hooks/rules-of-hooks

  useMemo(function () {
    var selectedPadding = getSelectedPadding(normalizeValues(paddingsConfig), globalsSelectedPadding);
    setStyle(selectedPadding);
  }, [paddingsConfig, globalsSelectedPadding]);
  return getStory(context);
};
export default withPaddings;